## ledger 3.0.0+dfsg3

=== CMakeLists.txt ===
--- 
+++ 
@@ -5,7 +5,7 @@
 set(Ledger_VERSION_MAJOR 3)
 set(Ledger_VERSION_MINOR 0)
 set(Ledger_VERSION_PATCH 0)
-set(Ledger_VERSION_DATE  20120518)
+set(Ledger_VERSION_DATE  20130529)
 
 enable_testing()
 
@@ -46,6 +46,10 @@
 find_package(PythonInterp)      # Used for running tests
 
 if(USE_PYTHON)
+  if(NOT BUILD_LIBRARY)
+    message(ERROR "Building the python module requires BUILD_LIBRARY=ON.")
+  endif()
+
   set(Python_ADDITIONAL_VERSIONS 2.7 2.6)
   find_package(PythonLibs)
   if(PYTHONLIBS_FOUND)
@@ -232,9 +236,6 @@
 ########################################################################
 
 macro(add_ledger_library_dependencies _target)
-  if(BUILD_LIBRARY)
-    target_link_libraries(${_target} libledger)
-  endif()
   target_link_libraries(${_target} ${MPFR_LIB})
   target_link_libraries(${_target} ${GMP_LIB})
   if(HAVE_EDIT)
@@ -292,6 +293,11 @@
 set (CPACK_PACKAGE_VERSION_MINOR "${Ledger_VERSION_MINOR}")
 set (CPACK_PACKAGE_VERSION_PATCH "${Ledger_VERSION_PATCH}")
 
+set (CPACK_SOURCE_GENERATOR "TBZ2")
+set (CPACK_SOURCE_PACKAGE_FILE_NAME
+  "${CMAKE_PROJECT_NAME}-${CPACK_PACKAGE_VERSION_MAJOR}.${CPACK_PACKAGE_VERSION_MINOR}.${CPACK_PACKAGE_VERSION_PATCH}")
+set (CPACK_SOURCE_IGNORE_FILES "/.git*;/.dir-locals.el;~$;/doc/website/;/doc/wiki/;/lib/*.sh;/lib/Makefile;/tools/;${CPACK_SOURCE_IGNORE_FILES}")
+
 include (CPack)
 
 ### CMakeLists.txt ends here
