=== test/CMakeLists.txt ===
--- 
+++ 
@@ -38,4 +38,16 @@
 add_subdirectory(baseline)
 add_subdirectory(regress)
 
+if(PYTHONINTERP_FOUND)
+  set(_class DocTests)
+  file(GLOB ${_class}_TESTS ${PROJECT_SOURCE_DIR}/doc/*.texi)
+  foreach(TestFile ${${_class}_TESTS})
+    get_filename_component(TestFile_Name ${TestFile} NAME_WE)
+    add_test(${_class}Test_${TestFile_Name}
+      ${PYTHON_EXECUTABLE} ${PROJECT_SOURCE_DIR}/test/DocTests.py
+      --ledger ${LEDGER_LOCATION} --file ${TestFile})
+    set_target_properties(check PROPERTIES DEPENDS ${_class}Test_${TestFile_Name})
+  endforeach()
+endif()
+
 ### CMakeLists.txt ends here
