=== debian/changelog ===
ledger (3.0.0+dfsg3-1~bpo70+1) wheezy-backports; urgency=low

  * Rebuild for wheezy-backports.

 -- Matt Palmer <mpalmer@debian.org>  Tue, 01 Jul 2014 08:19:32 +1000

ledger (3.0.0+dfsg3-1) unstable; urgency=medium

  * Depend on default boost version
  * Bug fix: "ledger-3 bundles non-dfsg software", thanks to
	  j@jamielinux.com</a>; (Closes: #741740). The bundled sha1
	  implementation is replaced by one from boost.
  * Bug fix: "missing licenses in debian/copyright", thanks to Thorsten
	  Alteholz (Closes: #741246).

 -- David Bremner <bremner@debian.org>  Sun, 13 Apr 2014 17:52:27 -0300

ledger (3.0.0+dfsg1-1) unstable; urgency=medium

  * New upstream tag v3.0. Only doc/test changes since last snapshot.

 -- David Bremner <bremner@debian.org>  Thu, 13 Mar 2014 08:30:06 -0300

ledger (3.0.0~20140226+bedae81+dfsg1-2) unstable; urgency=low

  * Split emacs interface to separate binary package. Install in a (more)
    debian-emacs-policy compliant way.

 -- David Bremner <bremner@debian.org>  Mon, 03 Mar 2014 10:59:11 -0400

ledger (3.0.0~20140226+bedae81+dfsg1-1) unstable; urgency=low

  * Updated git snapshot, by request to unstable (Closes: #604116)
  * Remove minified javascript files without corresponding source.  These
    are in the python bindings, so there should currently be no user
    visible effects (Closes: #736738).

 -- David Bremner <bremner@debian.org>  Sun, 02 Mar 2014 19:52:43 -0400

ledger (3.0.0~20130313+b608ed2-1) experimental; urgency=low

  * Updated git snapshot for experimental.
  * Remove special handling for timeclock.el, no longer shipped upstream.

 -- David Bremner <bremner@debian.org>  Sat, 16 Mar 2013 09:23:03 -0300

ledger (3.0.0~20130302+4810da9-1) experimental; urgency=low

  * Updated git snapshot for experimental (Closes: #701086).
  * Build system switched (upstream) to CMake.
  * Added trivial build-arch and build-indep targets
  * No longer install /usr/share/doc/ledger/examples/tools; not of
    interest to end-users.
  * Add hardening flags
  * Update Homepage, thanks to Ryan Kavanagh (Closes: #698239).
  * Add Vcs-Browser and Vcs-Git fields.
  * Use new emacs ledger mode (ldg-new.el) by default.
  * Link with -Wl,--as-needed to avoid depending on 2 extra boost libs.

 -- David Bremner <bremner@debian.org>  Tue, 05 Mar 2013 14:34:20 -0400
