## ledger 3.0.0+dfsg4

=== debian/changelog ===
ledger (3.0.0+dfsg4-2) unstable; urgency=high

  * Disable rpath for libledger.so (Closes: #760110).

 -- David Bremner <bremner@debian.org>  Sun, 31 Aug 2014 17:54:00 -0700

ledger (3.0.0+dfsg4-1) unstable; urgency=medium

  * Don't embed libutfcpp

 -- David Bremner <bremner@debian.org>  Thu, 28 Aug 2014 19:25:49 -0700
