=== debian/control ===
--- 
+++ 
@@ -8,7 +8,7 @@
 	libboost-date-time-dev, libboost-filesystem-dev,
 	libboost-iostreams-dev, libboost-serialization-dev,
 	libboost-test-dev, man2html-base, python, texinfo, texlive,
-	chrpath
+	chrpath, libutfcpp-dev
 Standards-Version: 3.9.3
 Homepage: http://ledger-cli.org
 Vcs-Git: git://anonscm.debian.org/git/collab-maint/ledger.git
