=== debian/rules ===
--- 
+++ 
@@ -79,7 +79,6 @@
 	# install the shared library privately.
 	mkdir -p $(CURDIR)/debian/ledger/usr/lib/ledger
 	cp $(BUILDDIR)/libledger.so.* $(CURDIR)/debian/ledger/usr/lib/ledger
-	chrpath -r /usr/lib/ledger $(CURDIR)/debian/ledger/usr/bin/ledger
 
 	# manually install the docs
 	cp -a $(BUILDDIR)/doc/ledger3.info* $(CURDIR)/debian/ledger/usr/share/info
